import { IPropVal, ICtx, ICtxRoot } from "./types";
import { tswRef } from "./ref";
export declare const enum NodeKind {
    first = 0,
    last = 1
}
export declare abstract class tswCtx implements ICtx {
    id: number;
    private propVals;
    private childCtxs;
    protected ctxParent: tswCtx | null | undefined;
    private static CtxLastId;
    constructor();
    getRootCtx(): ICtxRoot | undefined;
    getParent(): ICtx | null | undefined;
    addCtxToParent(ctxParent: tswCtx): void;
    addPropVal(propVal: IPropVal): void;
    protected shouldBeAddedToParent(): boolean | null | undefined;
    protected hasPropVals(): boolean | null | undefined;
    protected hasChildren(): boolean | null | undefined;
    protected forEachChild(action: (ctx: tswCtx) => void): void;
    removeChildren(): void;
    protected cleanup(): void;
    protected detachPropVals(): void;
    abstract update(): void;
    addRef(ref: tswRef<Element>): void;
    addChild(ctx: tswCtx): void;
    replaceNode(nodeKind: NodeKind, oldNode: Node | null, newNode: Node | null): void;
    protected notifySelfAndChildren(action: (ctx: tswCtx, beforeChildren: boolean) => void): void;
    domChange(beforeChildren: boolean, attach: boolean): void;
    dbg_getChildren(): Set<tswCtx> | undefined;
    dbg_getPropVals(): Set<IPropVal> | null | undefined;
}
export declare function isNotEmptySet<T>(s: Set<T> | null | undefined): boolean | null | undefined;
