import { tswCtx } from "./Ctx";
import { g_CurrentContext } from "./Scope";
export class tswCtxValue extends tswCtx {
    constructor(el, valuePropName, pv) {
        super();
        this.el = el;
        this.valuePropName = valuePropName;
        this.pv = pv;
    }
    setup(ctxParent) {
        this.setValue();
        this.addCtxToParent(ctxParent);
    }
    update() {
        if (this.ctxParent === null)
            return;
        this.removeChildren();
        this.setValue();
    }
    setValue() {
        g_CurrentContext.use(this, () => this._setValue());
    }
    _setValue() {
        const v = this.pv.get();
        const el = this.el;
        const currentValue = el[this.valuePropName];
        if (v !== currentValue) {
            el[this.valuePropName] = v;
        }
    }
    get dbg_el() { return this.el; }
}
