import { IPropVal, ICtx, PropDef, PropDefReadable } from './types';
export declare class tswPropVal<T> implements PropDef<T>, IPropVal {
    private ctxs;
    private insideSet;
    dbg_name: string | undefined;
    val: T;
    onChanged: (() => void) | undefined;
    constructor(initialValue: T, name?: string);
    dbg_ctxs(): Set<ICtx> | null | undefined;
    ctxRemove(ctx: ICtx): void;
    protected ctxAttach(): void;
    get(): T;
    set(v: T): void;
    protected updateContexts(): void;
    isTrue(contentTrue: any, contentFalse?: any): () => any;
    isFalse(content: any): () => any;
    isEqual(val: T, content: any): () => any;
    convert<U>(converter: {
        to: (v: T) => U;
        from: (v: U) => T;
    }): PropDef<U>;
    convert2<U>(to: (v: T) => U, from: (v: U) => T): PropDef<U>;
    to<U>(to: (v: T) => U): PropDefReadable<U>;
}
export declare class tswPropValArray<T> extends tswPropVal<T[]> {
    constructor(items: T[]);
    getItem(index: number): T;
    addItem(item: T, index?: number): void;
    delItem(item: T): void;
    removeItem(item: T): void;
    removeItemAt(index: number): void;
    setLength(length: number): void;
    sort(comparer?: (a: T, b: T) => number): void;
    modifyItems(action: (v: T[]) => void): void;
}
