import * as html from "./html";
export class tswRadioGroup {
    constructor(propVal, groupName) {
        this.ids = new Map();
        this.propVal = propVal;
        this.groupName = groupName;
    }
    radioButton(v, groupName) {
        const p = {
            get: () => this.propVal.get() == v,
            set: () => this.propVal.set(v),
        };
        return html.inputRadio().value(p).attr('name', groupName || this.groupName).id(this.getId(v));
    }
    label(v) {
        return html.label().forId(this.getId(v));
    }
    getId(v) {
        let id = this.ids.get(v);
        if (id == null) {
            id = this.getNextId();
            this.ids.set(v, id);
        }
        return id;
    }
    getNextId() {
        return 'radioButton-' + Math.round((Math.random() * 1000));
    }
}
