import { ElmEventMapItem } from "./types";
interface IEvent {
    target: any;
    type: string;
    preventDefault(): void;
}
export declare class tswRootEventHandler {
    htmlElement: Element;
    private eventHandlerDrivers;
    private eventHandlers;
    constructor(htmlElement: Element);
    attachElmEventHandler(el: Element, elmEventMapItem: ElmEventMapItem): void;
    detachElmEventHandlers(el: Element): void;
    hasHandlers(): boolean;
    getEventHandlerDriver(eventType: string): tswEventHandlerDriver;
    findEventHandlers(htmlElement: Node | null, eventName: string, eventType: string): {
        htmlElement: Node;
        elmHandlersItems: ElmEventMapItem[];
    } | null;
}
export declare class tswEventHandlerDriver {
    protected owner: tswRootEventHandler;
    static DriverTypes: Map<string, typeof tswEventHandlerDriver>;
    protected attachedEventListeners: Map<string, number>;
    protected eventsListener: (e: IEvent) => void;
    constructor(owner: tswRootEventHandler);
    attachEventListener(eventName: string): void;
    detachEventListener(eventName: string): void;
    getEventType(): string;
    protected addEventListener(eventName: string): void;
    protected removeEventListener(eventName: string): void;
    protected handleEvent(e: IEvent): void;
}
export declare class tswEventHandlerDriverDom extends tswEventHandlerDriver {
    static EventType: string;
    getEventType(): string;
    protected addEventListener(eventName: string): void;
    protected removeEventListener(eventName: string): void;
}
export {};
