class tswScope {
    constructor() {
        this.current = null;
    }
    getCurrentSafe() {
        const ctx = this.getCurrent();
        if (ctx == null)
            throw new Error("No current context.");
        return ctx;
    }
    getCurrent() {
        return this.current;
    }
    use(ctx, action) {
        const prevCtx = this.current;
        this.current = ctx;
        try {
            return action();
        }
        finally {
            this.current = prevCtx;
        }
    }
}
export const g_CurrentContext = new tswScope();
