import { tswRef } from './ref';
import { attrValType, childValType, boolValType, multiStringValType, singleStringValType, AttrNameValue, ElmEventMapItem, EventHandler, WindowEventMap2 } from "./types";
export declare namespace privates {
    namespace ElementGeneric {
        const tagName: unique symbol;
        const ns: unique symbol;
        const children: unique symbol;
        const addHandler: unique symbol;
        const attrs: unique symbol;
        const events: unique symbol;
        const getRefs: unique symbol;
    }
    namespace ElementWithValueBase {
        const getValueInfos: unique symbol;
    }
}
export declare class tswStyleRule {
    propName: string;
    propValue: singleStringValType;
    constructor(propName: string, propValue: singleStringValType);
}
export declare class tswElement {
    private _tagName;
    private _ns;
    private _attrs;
    private _children;
    private _eventHandlers;
    protected _refs: tswRef[] | undefined;
    constructor(tagName: string, ns?: string);
    attr(name: string, val: attrValType): this;
    id(val: singleStringValType): this;
    cls(val: multiStringValType): this;
    style(val: multiStringValType): this;
    styleRule(name: string, val: singleStringValType): this;
    data(name: string, val: singleStringValType): this;
    disabled(val: boolValType): this;
    hidden(val: boolValType): this;
    children(items: childValType): this;
    onClick(handler: EventHandler<MouseEvent> | null | undefined): this;
    onEvent<K extends keyof WindowEventMap2>(eventName: K, handler: EventHandler<WindowEventMap2[K]> | null | undefined): this;
    onEvent(eventName: string, handler: EventHandler<Event> | null | undefined): this;
    onEventDirect<K extends keyof WindowEventMap2>(eventName: K, handler: EventHandler<WindowEventMap2[K]> | null | undefined): this;
    [privates.ElementGeneric.addHandler](item: ElmEventMapItem): void;
    addRef(ref: tswRef<Element> | null): this;
    private addAttr;
    [privates.ElementGeneric.tagName](): string;
    [privates.ElementGeneric.ns](): string | undefined;
    [privates.ElementGeneric.children](): childValType[] | undefined;
    [privates.ElementGeneric.attrs](): AttrNameValue[] | undefined;
    [privates.ElementGeneric.events](): ElmEventMapItem[] | undefined;
    [privates.ElementGeneric.getRefs](): tswRef<Element>[] | undefined;
}
